#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define TL 1
#define TC 2
#define TR 3
#define BL 4
#define BC 5
#define BR 6
#define CL 7
#define CC 8
#define CR 9
char	*mat, *nam;
char	*b_t;
int  	reverse = 0;		/* for reversed normals and wireframe representation */
int  	caso;
int	p_t = 8;
double	p_v[8][3];		/* pyr points */
double	lg, wd, hg, radius;	/* pyr sizes */
double	t_an = 10000, an;	/* tapper angle */

main(argc,argv)
int     argc;
char    *argv[];
{
        if (argc < 9 || argc > 11) 
		usage();
        else if (argc == 10 || argc == 11) {
		if(argv[9][0]=='c'||argv[9][0]=='C'){
			if(argv[9][1]=='c'||argv[9][1]=='C')
				p_t=CC;
			else if(argv[9][1]=='l'||argv[9][1]=='L')
				p_t=CL;
			else if(argv[9][1]=='r'||argv[9][1]=='R')
				p_t=CR;
			else 
				usage();
		}
		else if(argv[9][0]=='t'||argv[9][0]=='T'){
			if(argv[9][1]=='c'||argv[9][1]=='C')
				p_t=TC;
			else if(argv[9][1]=='l'||argv[9][1]=='L')
				p_t=TL;
			else if(argv[9][1]=='r'||argv[9][1]=='R')
				p_t=TR;
			else 
				usage();
		}
		else if(argv[9][0]=='b'||argv[9][0]=='B'){
			if(argv[9][1]=='c'||argv[9][1]=='C')
				p_t=BC;
			else if(argv[9][1]=='l'||argv[9][1]=='L')
				p_t=BL;
			else if(argv[9][1]=='r'||argv[9][1]=='R')
				p_t=BR;
			else 
				usage();
		}
		else{
				usage();
		}
		if(argc == 11) {
        		t_an = atof(argv[10]);
			if(t_an < 0 || t_an > 90)
				usage();
			else if(t_an == 0 )
				t_an == 0.0001;
			else if(t_an == 90 )
				t_an == 89.999;

			an = (90-t_an) * M_PI / 180;
		}
        }

	mat = argv[1];
	nam = argv[2];
	b_t = argv[3];
	if(b_t[0]!='s'){
		if(b_t[0]!='S'){
			if(b_t[0]!='t'){
				if(b_t[0]!='T'){
					usage();
				}
			}
		}
	}
	if(argv[4][0]!='-')
		usage();
	else{
		if(argv[4][1]=='i'||argv[4][1]=='I')
			reverse = 1;	/* reversed normal */
		else if(argv[4][1]=='o'||argv[4][1]=='O')
			reverse = 0;	/* inversed normal */
		else if(argv[4][1]=='w'||argv[4][1]=='W')
			reverse = 2;	/* wireframe */
		else
			usage();
	}
        radius   = atof(argv[5]);
        lg       = atof(argv[6]);
        wd       = atof(argv[7]);
        hg       = atof(argv[8]);

	calculation();
	torad();
}
/*____________________________________________________*/
calculation()
{
	double	li, ht;

/* BOTTOM BASE	*/
	p_v[0][0]=0;  p_v[0][1]=0;  p_v[0][2]=0;
	p_v[1][0]=lg; p_v[1][1]=0;  p_v[1][2]=0;
	p_v[2][0]=lg; p_v[2][1]=wd; p_v[2][2]=0;
	p_v[3][0]=0;  p_v[3][1]=wd; p_v[3][2]=0;
	
/* TOP BASE	*/
	if(t_an > 90){
		caso1();
	}
	else{
		if(wd-lg > lg-wd)
			li=wd;
		else
			li=lg;
		ht = li/2 * tan(an);
		if(ht < hg){
			hg=ht;
			caso1();
		}
		else {
			caso2();
		}
	}
}
/*____________________________________________________*/
caso1()
{
	p_v[4][2] = hg;
/* CALCULATING THE X COORDS	*/
	if(p_t == TL || p_t == CL || p_t == BL ){
		p_v[4][0] = 0;
	}
	else if(p_t == TC || p_t == CC || p_t == BC ){
		p_v[4][0] = lg/2;
	}
	else if(p_t == TR || p_t == CR || p_t == BR ){
		p_v[4][0] =  lg;
	}
/* CALCULATING THE Y COORDS	*/
	if(p_t == TL || p_t == TC || p_t == TR ){
		p_v[4][1] = wd;
	}
	else if(p_t == CL || p_t == CC || p_t == CR ){
		p_v[4][1] = wd/2;
	}
	else if(p_t == BL || p_t == BC || p_t == BR ){
		p_v[4][1] = 0;
	}
	
	caso=1;
}
/*____________________________________________________*/
caso2()
{
	float	dis, flagx=0.001, flagy=0.001;

/* CALCULATING THE Z COORDS	*/
	p_v[4][2] = p_v[5][2] = p_v[6][2] = p_v[7][2] = hg;

	if(hg / tan(an) > lg/2){
		dis = lg/2;
		flagx=0.001;
	}
	else{
		dis = hg / tan(an);
	}
/* CALCULATING THE X COORDS	*/
	if(p_t == TL || p_t == CL || p_t == BL ){
		p_v[4][0] = p_v[7][0] = 0;
		p_v[5][0] = p_v[6][0] = (lg - dis - dis) + flagx;
	}
	else if(p_t == TC || p_t == CC || p_t == BC ){
		p_v[4][0] = p_v[7][0] = dis - flagx;
		p_v[5][0] = p_v[6][0] = lg - dis + flagx;
	}
	else if(p_t == TR || p_t == CR || p_t == BR ){
		p_v[4][0] =  p_v[7][0] = (dis + dis) - flagx;
		p_v[5][0] =  p_v[6][0] = lg;
	}


	if(hg / tan(an) > wd/2){
		dis = wd/2;
		flagy=0.001;
	}
	else{
		dis = hg / tan(an);
	}
/* CALCULATING THE Y COORDS	*/
	if(p_t == TL || p_t == TC || p_t == TR ){
		p_v[4][1] = p_v[5][1] = (dis + dis) - flagy;
		p_v[6][1] = p_v[7][1] = wd;
	}
	else if(p_t == CL || p_t == CC || p_t == CR ){
		p_v[4][1] = p_v[5][1] = dis - flagy;
		p_v[6][1] = p_v[7][1] = wd - dis + flagy;
	}
	else if(p_t == BL || p_t == BC || p_t == BR ){
		p_v[4][1] =  p_v[5][1] = 0;
		p_v[6][1] =  p_v[7][1] = (wd - dis - dis) + flagy;
	}
	
	caso=2;
}
/*____________________________________________________*/
torad()
{

    if(reverse == 0){   /* PRINTING WITH ALL THE NORMALS POINTING OUTSIDE */
	printf("%s polygon %s.1 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[3][0],p_v[3][1],p_v[3][2],
	p_v[2][0],p_v[2][1],p_v[2][2],p_v[1][0],p_v[1][1],p_v[1][2]);	/* BOTTOM BASE */
	if(caso == 1){
	    printf("%s polygon %s.2 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[1][0],p_v[1][1],p_v[1][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* SOUTH */

	    printf("%s polygon %s.3 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[1][0],p_v[1][1],p_v[1][2],p_v[2][0],p_v[2][1],p_v[2][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* EAST */

	    printf("%s polygon %s.4 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[3][0],p_v[3][1],p_v[3][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* NORTH */

	    printf("%s polygon %s.5 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[3][0],p_v[3][1],p_v[3][2],p_v[0][0],p_v[0][1],p_v[0][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* WEST */
	}
	else{
	    printf("%s polygon %s.2 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[1][0],p_v[1][1],p_v[1][2],
	    p_v[5][0],p_v[5][1],p_v[5][2],p_v[4][0],p_v[4][1],p_v[4][2]);	/* SOUTH */

	    printf("%s polygon %s.3 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[1][0],p_v[1][1],p_v[1][2],p_v[2][0],p_v[2][1],p_v[2][2],
	    p_v[6][0],p_v[6][1],p_v[6][2],p_v[5][0],p_v[5][1],p_v[5][2]);	/* EAST */

	    printf("%s polygon %s.4 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[3][0],p_v[3][1],p_v[3][2],
	    p_v[7][0],p_v[7][1],p_v[7][2],p_v[6][0],p_v[6][1],p_v[6][2]);	/* NORTH */

	    printf("%s polygon %s.5 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[3][0],p_v[3][1],p_v[3][2],p_v[0][0],p_v[0][1],p_v[0][2],
	    p_v[4][0],p_v[4][1],p_v[4][2],p_v[7][0],p_v[7][1],p_v[7][2]);	/* WEST */

	    printf("%s polygon %s.6 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[4][0],p_v[4][1],p_v[4][2],p_v[5][0],p_v[5][1],p_v[5][2],
	    p_v[6][0],p_v[6][1],p_v[6][2],p_v[7][0],p_v[7][1],p_v[7][2]);	/* TOP BASE */
	}
    }
    else if(reverse == 1){   /* PRINTING WITH ALL THE NORMALS POINTING INSIDE */
	printf("%s polygon %s.1 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[1][0],p_v[1][1],p_v[1][2],
	p_v[2][0],p_v[2][1],p_v[2][2],p_v[3][0],p_v[3][1],p_v[3][2]);	/* BOTTOM BASE */
	if(caso == 1){
	    printf("%s polygon %s.2 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[1][0],p_v[1][1],p_v[1][2],p_v[0][0],p_v[0][1],p_v[0][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* SOUTH */

	    printf("%s polygon %s.3 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[1][0],p_v[1][1],p_v[1][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* EAST */

	    printf("%s polygon %s.4 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[3][0],p_v[3][1],p_v[3][2],p_v[2][0],p_v[2][1],p_v[2][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* NORTH */

	    printf("%s polygon %s.5 0 0 9 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[3][0],p_v[3][1],p_v[3][2],
	    p_v[4][0],p_v[4][1],p_v[4][2]);				/* WEST */
	}
	else{
	    printf("%s polygon %s.2 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[1][0],p_v[1][1],p_v[1][2],p_v[0][0],p_v[0][1],p_v[0][2],
	    p_v[4][0],p_v[4][1],p_v[4][2], p_v[5][0],p_v[5][1],p_v[5][2]);	/* SOUTH */

	    printf("%s polygon %s.3 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[1][0],p_v[1][1],p_v[1][2],
	    p_v[5][0],p_v[5][1],p_v[5][2], p_v[6][0],p_v[6][1],p_v[6][2]);	/* EAST */

	    printf("%s polygon %s.4 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[3][0],p_v[3][1],p_v[3][2],p_v[2][0],p_v[2][1],p_v[2][2],
	    p_v[6][0],p_v[6][1],p_v[6][2],p_v[7][0],p_v[7][1],p_v[7][2]);	/* NORTH */

	    printf("%s polygon %s.5 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[3][0],p_v[3][1],p_v[3][2],
	    p_v[7][0],p_v[7][1],p_v[7][2], p_v[4][0],p_v[4][1],p_v[4][2]);	/* WEST */

	    printf("%s polygon %s.6 0 0 12 %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[5][0],p_v[5][1],p_v[5][2],p_v[4][0],p_v[4][1],p_v[4][2],
	    p_v[7][0],p_v[7][1],p_v[7][2], p_v[6][0],p_v[6][1],p_v[6][2]);	/* TOP BASE */
	}
    }
    else if(reverse == 2){   /* PRINTING FOR WIREFRAME REPRESENTATION */
	printf("%s cylinder %s.wbb.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[1][0],p_v[1][1],p_v[1][2], radius);
	printf("%s cylinder %s.wbb.2 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[1][0],p_v[1][1],p_v[1][2], p_v[2][0],p_v[2][1],p_v[2][2], radius);
	printf("%s cylinder %s.wbb.3 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[3][0],p_v[3][1],p_v[3][2], radius);
	printf("%s cylinder %s.wbb.4 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[3][0],p_v[3][1],p_v[3][2], p_v[0][0],p_v[0][1],p_v[0][2], radius);	/* BOTTOM BASE */
	
	printf("%s sphere %s.v0 0 0 4 %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[0][0],p_v[0][1],p_v[0][2], radius);
	printf("%s sphere %s.v1 0 0 4 %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[1][0],p_v[1][1],p_v[1][2], radius);
	printf("%s sphere %s.v2 0 0 4 %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[2][0],p_v[2][1],p_v[2][2], radius);
	printf("%s sphere %s.v3 0 0 4 %.3f %.3f %.3f %.3f\n",
	mat,nam,p_v[3][0],p_v[3][1],p_v[3][2], radius);
	if(caso == 1){
	    printf("%s cylinder %s.wsf.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[4][0],p_v[4][1],p_v[4][2], radius);
	    printf("%s cylinder %s.wsf.2 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[1][0],p_v[1][1],p_v[1][2],p_v[4][0],p_v[4][1],p_v[4][2], radius);/* SOUTH */

	    printf("%s cylinder %s.wef.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[4][0],p_v[4][1],p_v[4][2], radius);/* EAST */

	    printf("%s cylinder %s.wnf.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[3][0],p_v[3][1],p_v[3][2],p_v[4][0],p_v[4][1],p_v[4][2], radius);/* NORTH */
		
	    printf("%s sphere %s.v4 0 0 4 %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[4][0],p_v[4][1],p_v[4][2], radius);
	}
	else{
	    printf("%s cylinder %s.wtb.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[4][0],p_v[4][1],p_v[4][2],p_v[5][0],p_v[5][1],p_v[5][2], radius);
	    printf("%s cylinder %s.wtb.2 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[5][0],p_v[5][1],p_v[5][2], p_v[6][0],p_v[6][1],p_v[6][2], radius);
	    printf("%s cylinder %s.wtb.3 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[6][0],p_v[6][1],p_v[6][2],p_v[7][0],p_v[7][1],p_v[7][2], radius);
	    printf("%s cylinder %s.wtb.4 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[7][0],p_v[7][1],p_v[7][2], p_v[4][0],p_v[4][1],p_v[4][2], radius);/* TOP BASE */
	
	    printf("%s sphere %s.v4 0 0 4 %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[4][0],p_v[4][1],p_v[4][2], radius);
	    printf("%s sphere %s.v5 0 0 4 %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[5][0],p_v[5][1],p_v[5][2], radius);
	    printf("%s sphere %s.v6 0 0 4 %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[6][0],p_v[6][1],p_v[6][2], radius);
	    printf("%s sphere %s.v7 0 0 4 %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[7][0],p_v[7][1],p_v[7][2], radius);
	    
	    printf("%s cylinder %s.wsf.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[0][0],p_v[0][1],p_v[0][2],p_v[4][0],p_v[4][1],p_v[4][2], radius);				
	    printf("%s cylinder %s.wsf.2 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[1][0],p_v[1][1],p_v[1][2],p_v[5][0],p_v[5][1],p_v[5][2], radius);/* SOUTH */

	    printf("%s cylinder %s.wef.1 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[2][0],p_v[2][1],p_v[2][2],p_v[6][0],p_v[6][1],p_v[6][2], radius);/* EAST */

	    printf("%s cylinder %s.wnf.2 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
	    mat,nam,p_v[3][0],p_v[3][1],p_v[3][2],p_v[7][0],p_v[7][1],p_v[7][2], radius);/* NORTH */
	}
    }
}
/*____________________________________________________*/
usage()
{
	fprintf(stderr,"-------------------------------------------------------- \n");
	fprintf(stderr,"genpyr is a Radiance utility for creating a pyramid\n");
	fprintf(stderr,"primitive\n");
	fprintf(stderr,"Abraham Yezioro, Fac. of Architecture - TECHNION, Israel \n");
	fprintf(stderr,"-------------------------------------------------------- \n");
	fprintf(stderr,"genpyr usage:\n");
	fprintf(stderr,"genpyr mat name s show_type radius xsize ysize zsize [opt] [taper angle]\n\n");
	fprintf(stderr,"s is a parameter for future development of this function\n");
	fprintf(stderr,"show_type is to show the pyramid as surfaces or as wireframe:\n");
	fprintf(stderr,"-i --> normal inversed,  -o --> normal outside,  -w --> wireframe\n");
	fprintf(stderr,"radius    : When show_type is w (wire frame) this option must get a value\n");
	fprintf(stderr,"          : greater than 0. In show_type -i or -o (surface) radius value \n");
	fprintf(stderr,"          : is irrelevant, however you must give any (0)\n");
	fprintf(stderr,"Options (the options are for the placement of the top base):\n");
	fprintf(stderr,"tl, tc, tr: top left, center, right\n");
	fprintf(stderr,"bl, bc, br: bottom left, center, right\n");
	fprintf(stderr,"cl, cc, cr: center left, center, right\n\n");
	fprintf(stderr,"The taper angle allows create tapered pyramids. The value must:\n");
	fprintf(stderr,"lie between 0 and 90 (0 --> vertical,  90 --> horizontal.\n");
	fprintf(stderr,"Example:\n");
	fprintf(stderr,"To create a wire framed pyramid of 8 X units and 8 Y units with \n");
	fprintf(stderr,"a height of 6 Z units centered at the top, and with a tapper angle \n");
	fprintf(stderr,"of 30 degrees (the radius of the poles is 0.20 units), write:\n\n");
	fprintf(stderr,"genpyr red_plastic pyr1 s -w 0.2 8 8 6 cc 30\n\n\n");
        exit();
}
